// MediaBase.cpp: BonfBANX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "MediaBase.h"


/////////////////////////////////////////////////////////////////////////////
// IMediaDataNX
/////////////////////////////////////////////////////////////////////////////

#define	MINBUFSIZE	256UL		// ŏobt@TCY
#define MINADDSIZE	256UL		// ŏǉmۃTCY


BYTE * CMediaData::GetData(void) const
{
	// obt@|C^擾
	return (m_dwDataSize)? m_pData : NULL;
}

const DWORD CMediaData::GetSize(void) const
{
	// f[^TCY擾
	return m_dwDataSize;
}

void CMediaData::SetAt(const DWORD dwPos, const BYTE byData)
{
	// 1oCgZbg
	if(dwPos < m_dwDataSize)m_pData[dwPos] = byData;
}

const BYTE CMediaData::GetAt(const DWORD dwPos) const
{
	// 1oCg擾
	return (dwPos < m_dwDataSize)? m_pData[dwPos] : 0x00U;
}

const DWORD CMediaData::SetData(const BYTE *pData, const DWORD dwDataSize)
{
	if(dwDataSize){
		// obt@m
		GetBuffer(dwDataSize);

		// f[^Zbg
		::CopyMemory(m_pData, pData, dwDataSize);
		}

	// TCYZbg
	m_dwDataSize = dwDataSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::AddData(const BYTE *pData, const DWORD dwDataSize)
{
	if(!dwDataSize)return m_dwDataSize;

	// obt@m
	GetBuffer(m_dwDataSize + dwDataSize);
	
	// f[^ǉ
	::CopyMemory(&m_pData[m_dwDataSize], pData, dwDataSize);

	// TCYZbg
	m_dwDataSize += dwDataSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::AddData(const IMediaData *pData)
{
	return AddData(pData->GetData(), pData->GetSize());
}

const DWORD CMediaData::AddByte(const BYTE byData)
{
	// obt@m
	GetBuffer(m_dwDataSize + 1UL);
	
	// f[^ǉ
	m_pData[m_dwDataSize] = byData;

	// TCYXV
	m_dwDataSize++;

	return m_dwDataSize;
}

const DWORD CMediaData::TrimHead(const DWORD dwTrimSize)
{
	// f[^擪؂l߂
	if(!m_dwDataSize || !dwTrimSize){
		// Ȃ
		}
	else if(dwTrimSize >= m_dwDataSize){
		// Ŝ؂l߂
		m_dwDataSize = 0UL;		
		}
	else{
		// f[^ړ
		::MoveMemory(m_pData, m_pData + dwTrimSize, m_dwDataSize - dwTrimSize);
		m_dwDataSize -= dwTrimSize;
		}

	return m_dwDataSize;
}

const DWORD CMediaData::TrimTail(const DWORD dwTrimSize)
{
	// f[^؂l߂
	if(!m_dwDataSize || !dwTrimSize){
		// Ȃ
		}
	else if(dwTrimSize >= m_dwDataSize){
		// Ŝ؂l߂
		m_dwDataSize = 0UL;		
		}
	else{
		// f[^؂l߂
		m_dwDataSize -= dwTrimSize;
		}

	return m_dwDataSize;
}

const DWORD CMediaData::CopyData(const IMediaData *pSrc)
{
	if(!pSrc)return 0UL;

	// f[^̃Rs[
	return SetData(pSrc->GetData(), pSrc->GetSize());
}

const DWORD CMediaData::GetBuffer(const DWORD dwGetSize)
{
	if(dwGetSize <= m_dwBuffSize)return m_dwBuffSize;

	// ȂƂwTCYi[łobt@mۂ
	if(!m_pData){
		// obt@mۂ܂
		m_dwBuffSize = (dwGetSize > MINBUFSIZE)? dwGetSize : MINBUFSIZE;
		m_pData = new BYTE [m_dwBuffSize];
		}
	else if(dwGetSize > m_dwBuffSize){
		// vTCY̓obt@TCY𒴂
		m_dwBuffSize = (dwGetSize > MINBUFSIZE)? dwGetSize : MINBUFSIZE;
		if(m_dwBuffSize < (m_dwDataSize * 2UL))m_dwBuffSize = m_dwDataSize * 2UL;

		BYTE *pNewBuffer = new BYTE [m_dwBuffSize];

		// f[^Rs[
		if(m_dwDataSize){
			::CopyMemory(pNewBuffer, m_pData, m_dwDataSize);
			}
		
		// obt@J
		delete [] m_pData;

		// obt@ւ
		m_pData = pNewBuffer;
		}

	return m_dwBuffSize;
}

const DWORD CMediaData::SetSize(const DWORD dwSetSize)
{
	if(dwSetSize){
		// obt@m
		GetBuffer(dwSetSize);
		}

	// TCYZbg
	m_dwDataSize = dwSetSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::SetSize(const DWORD dwSetSize, const BYTE byFiller)
{
	// TCYZbg
	SetSize(dwSetSize);
	
	// f[^Zbg
	if(dwSetSize){
		::FillMemory(m_pData, dwSetSize, byFiller);
		}
		
	return m_dwDataSize;
}

void CMediaData::ClearSize(void)
{
	// f[^TCYNA
	m_dwDataSize = 0UL;
}

CMediaData::CMediaData(IBonObject *pOwner)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(NULL)
{
	// ̃obt@𐶐
}

CMediaData::CMediaData(const CMediaData &Operand)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(NULL)
{
	// Rs[RXgN^
	*this = Operand;
}

CMediaData::CMediaData(const DWORD dwBuffSize)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(NULL)
{
	// obt@TCYw肵ăobt@𐶐
	GetBuffer(dwBuffSize);
}

CMediaData::CMediaData(const BYTE *pData, const DWORD dwDataSize)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(NULL)
{
	// f[^lw肵ăobt@𐶐
	SetData(pData, dwDataSize);
}

CMediaData::CMediaData(const BYTE byFiller, const DWORD dwDataSize)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(NULL)
{
	// tBf[^w肵ăobt@𐶐
	SetSize(dwDataSize, byFiller);
}

CMediaData::~CMediaData(void)
{
	// obt@J
	if(m_pData)delete [] m_pData;
}

CMediaData & CMediaData::operator = (const CMediaData &Operand)
{
	// obt@TCY̏܂ł̓Rs[Ȃ
	SetData(Operand.GetData(), Operand.GetSize());

	return *this;
}


/////////////////////////////////////////////////////////////////////////////
// IMediaDecoderNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CMediaDecoder::GetInputNum(void) const
{
	// ͐Ԃ
	return m_dwInputNum;
}

const DWORD CMediaDecoder::GetOutputNum(void) const
{
	// o͐Ԃ
	return m_dwOutputNum;
}

const bool CMediaDecoder::PlayDecoder(void)
{
	DWORD dwOutputIndex;

	// ŏɉʃfR[_Đ(͏dv)
	for(dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->PlayDecoder())break;
			}
		}

	// G[͍Đς݃fR[_~
	if(dwOutputIndex < GetOutputNum()){
		while(dwOutputIndex--){
			if(m_aOutputDecoder[dwOutputIndex].pDecoder){
				m_aOutputDecoder[dwOutputIndex].pDecoder->StopDecoder();
				}
			}
		return false;
		}
	
	// ŌɎfR[_Đ
	return OnPlay();
}

const bool CMediaDecoder::StopDecoder(void)
{
	bool bReturn = true;

	// ŏɎfR[_~
	if(!OnStop()){
		bReturn = false;
		}

	// ɉʃfR[_~(͏dv)
	for(DWORD dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->StopDecoder()){
				bReturn = false;
				}
			}
		}

	return bReturn;
}

const bool CMediaDecoder::ResetDecoder(void)
{
	bool bReturn = true;

	// fR[_OtbN
	if(m_pLock)m_pLock->Lock();

	// ŏɉʃfR[_Zbg(͏dv)
	for(DWORD dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->ResetDecoder()){
				bReturn = false;
				}
			}
		}

	// ŌɎfR[_Zbg
	if(!OnReset()){
		bReturn = false;
		}

	// fR[_OtAbN
	if(m_pLock)m_pLock->Unlock();

	return bReturn;
}

const bool CMediaDecoder::SetOutputDecoder(IMediaDecoder *pDecoder, const DWORD dwOutputIndex, const DWORD dwInputIndex)
{
	// o̓fR[_Zbg
	if(dwOutputIndex < GetOutputNum()){
		m_aOutputDecoder[dwOutputIndex].pDecoder = pDecoder;
		m_aOutputDecoder[dwOutputIndex].dwInputIndex = dwInputIndex;
		return true;
		}

	return false;
}

const bool CMediaDecoder::InputMedia(IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// ɃG[Ԃ
	return false;
}

CMediaDecoder::CMediaDecoder(IBonObject *pOwner, const DWORD dwInputNum, const DWORD dwOutputNum, CSmartLock *pLock)
	: CBonObject(pOwner)
	, m_pEventHandler(dynamic_cast<IMediaDecoderHandler *>(pOwner))
	, m_dwInputNum(dwInputNum)
	, m_dwOutputNum(dwOutputNum)
	, m_pLock(pLock)
{
	// o̓fR[_zNA
	::ZeroMemory(m_aOutputDecoder, sizeof(m_aOutputDecoder));
}

CMediaDecoder::~CMediaDecoder(void)
{
	// NeBJZNVJ
	if(m_pLock)delete m_pLock;
}

const bool CMediaDecoder::OnPlay(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OnStop(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OnReset(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OutputMedia(IMediaData *pMediaData, const DWORD dwOutptIndex)
{
	// o̓fR[_Ƀf[^n
	if(dwOutptIndex < GetOutputNum()){
		if(m_aOutputDecoder[dwOutptIndex].pDecoder){
			return m_aOutputDecoder[dwOutptIndex].pDecoder->InputMedia(pMediaData, m_aOutputDecoder[dwOutptIndex].dwInputIndex);
			}
		}

	return false;
}

const DWORD CMediaDecoder::SendDecoderEvent(const DWORD dwEventID, PVOID pParam)
{
	// Cxgʒm
	return (m_pEventHandler)? m_pEventHandler->OnDecoderEvent(this, dwEventID, pParam) : 0UL;
}
