// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonCoreEngine.h"
#include "BonClassEnumerator.h"

#include "MediaBase.h"
#include "SmartFile.h"
#include "SmartSocket.h"
#include "RegCfgStorage.h"
#include "IniCfgStorage.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[Jϐ
/////////////////////////////////////////////////////////////////////////////

static CBonCoreEngine BonEngine(NULL);


/////////////////////////////////////////////////////////////////////////////
// t@C[J֐vg^Cv
/////////////////////////////////////////////////////////////////////////////

static void RegisterClass(void);


/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch(ul_reason_for_call){
		case DLL_PROCESS_ATTACH :

			// [NoL
			_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_LEAK_CHECK_DF); 

			// RAGWX^[gAbv
			BonEngine.Startup(hModule);

			// WNXo^
			::RegisterClass();

			// BonW[[h
			BonEngine.RegisterBonModule();

			break;

		case DLL_PROCESS_DETACH :

			// RAGWVbg_E
			BonEngine.Shutdown();

			break;
		}

	return TRUE;
}

static void RegisterClass(void)
{
	// NXt@Ng[o^(Wgݍ݃NX)
	::BON_REGISTER_CLASS<CBonCoreEngine>();
	::BON_REGISTER_CLASS<CBonClassEnumerator>();

	::BON_REGISTER_CLASS<CMediaData>();
	::BON_REGISTER_CLASS<CSmartFile>();
	::BON_REGISTER_CLASS<CSmartSocket>();
	::BON_REGISTER_CLASS<CRegCfgStorage>();
	::BON_REGISTER_CLASS<CIniCfgStorage>();
}


/////////////////////////////////////////////////////////////////////////////
// GNX|[gAPI
/////////////////////////////////////////////////////////////////////////////

BONAPI const BONGUID BON_NAME_TO_GUID(LPCTSTR lpszName)
{
	// W[/NX/C^tF[XGUIDɕϊ
	return BonEngine.BonNameToGuid(lpszName);
}

BONAPI IBonObject * BON_CREATE_INSTANCE(LPCTSTR lpszClassName, IBonObject *pOwner)
{
	// NXCX^X
	return BonEngine.BonCreateInstance(lpszClassName, pOwner);
}

BONAPI const bool QUERY_BON_MODULE(LPCTSTR lpszModuleName)
{
	// W[̗LԂ
	return BonEngine.QueryBonModule(lpszModuleName);
}

BONAPI const DWORD GET_BON_MODULE_NAME(const BONGUID ModuleId, LPTSTR lpszModuleName)
{
	// W[GUID𖼑Oɕϊ
	return BonEngine.GetBonModuleName(ModuleId, lpszModuleName);
}

BONAPI const bool REGISTER_BON_CLASS(LPCTSTR lpszClassName, const CLASSFACTORYMETHOD pfnClassFactory, const DWORD dwPriority)
{
	// NXo^
	return BonEngine.RegisterBonClass(lpszClassName, pfnClassFactory, dwPriority);
}

BONAPI const bool QUERY_BON_CLASS(LPCTSTR lpszClassName)
{
	// NX̗LԂ
	return BonEngine.QueryBonClass(lpszClassName);
}

BONAPI const DWORD GET_BON_CLASS_NAME(const BONGUID ClassId, LPTSTR lpszClassName)
{
	// NXGUID𖼑Oɕϊ
	return BonEngine.GetBonClassName(ClassId, lpszClassName);
}

BONAPI const BONGUID GET_BON_CLASS_MODULE(const BONGUID ClassId)
{
	// NX񋟂郂W[GUIDԂ
	return BonEngine.GetBonClassModule(ClassId);
}

BONAPI IBonObject * GET_STOCK_INSTANCE(LPCTSTR lpszClassName)
{
	// XgbNCX^XԂ
	return BonEngine.GetStockInstance(lpszClassName);
}

BONAPI const bool REGISTER_STOCK_INSTANCE(LPCTSTR lpszClassName, IBonObject *pInstance)
{
	// XgbNCX^Xo^
	return BonEngine.RegisterStockInstance(lpszClassName, pInstance);
}

BONAPI const bool UNREGISTER_STOCK_INSTANCE(LPCTSTR lpszClassName)
{
	// XgbNCX^X폜
	return BonEngine.UnregisterStockInstance(lpszClassName);
}
