// SmartThread.h: X}[gXbhNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// X}[gXbhNX
/////////////////////////////////////////////////////////////////////////////

template <class T> class CSmartThread
{
public:
	// Xbh\bh^
	typedef void (T::*TAGET_FUNC)(CSmartThread *pThread, bool &bKillSignal, PVOID pParam);

	CSmartThread(void)
		: m_pThreadOwner(NULL)
		, m_pTargetFunc(NULL)
		, m_pThreadParam(NULL)
		, m_hThread(NULL)
		, m_dwThreadID(0UL)
		, m_bKillSignal(true)
		, m_bSyncSignal(false)
	{
	
	}
	
	~CSmartThread(void)
	{
		EndThread();
	}

	const bool StartThread(T *pOwner, TAGET_FUNC pTargetFunc, PVOID pThreadParam = NULL, const bool bStart = true)
	{
		if(!pOwner || !pTargetFunc)return false;
		
		// JĂȂꍇ͊J
		if(m_hThread)::CloseHandle(m_hThread);
	
		// ֐|C^Ap[^ۑ
		m_pThreadOwner = pOwner;
		m_pTargetFunc = pTargetFunc;
		m_pThreadParam = pThreadParam;
		
		// VOiNA
		m_bSyncSignal = false;
		m_bKillSignal = false;
		
		// XbhN
		if(!(m_hThread = ::CreateThread(NULL, 0UL, CSmartThread::ThreadFunc, static_cast<LPVOID>(this), (bStart)? 0UL : CREATE_SUSPENDED, &m_dwThreadID))){
			// XbhNs
			return false;
			}

		// XbhN҂
		if(bStart){
			while(!m_bSyncSignal)::Sleep(0);
			}	

		return true;
	}

	const bool EndThread(const bool bPumpMessage = false)
	{
		if(!m_hThread)return false;
	
		// IVOiZbg
		m_bKillSignal = true;

		// Xbh̒Ăяoꍇ͊JȂ
		if(::GetCurrentThreadId() == m_dwThreadID)return true;
	
		// TXyhԂ̂Ƃ̓W[
		::ResumeThread(m_hThread);

		// I҂
		while(m_bSyncSignal){
			if(!bPumpMessage)::Sleep(0);
			else PumpMessage();
			}

		// XbhJ
		::CloseHandle(m_hThread);
		m_hThread = NULL;

		return true;	
	}
	
	const bool SuspendThread(void)
	{
		if(!m_hThread)false;

		// XbhTXyh
		::SuspendThread(m_hThread);
	
		return true;	
	}
	
	const bool ResumeThread(void)
	{
		if(!m_hThread)false;

		// XbhW[
		::ResumeThread(m_hThread);
	
		return true;	
	}

	const HANDLE GetThreadHandle(void) const
	{
		// XbhnhԂ
		return m_hThread;	
	}
	
	const DWORD GetThreadID(void) const
	{
		// XbhIDԂ
		return m_dwThreadID;
	}

	const bool IsRunning(void) const
	{
		// XbhsLԂ
		return m_bSyncSignal;
	}
	
protected:
	static DWORD WINAPI ThreadFunc(LPVOID pParam)
	{
		CSmartThread *pThis = static_cast<CSmartThread *>(pParam);

		// TXyhԂŏI
		if(pThis->m_bKillSignal){
			pThis->m_bSyncSignal = false;
			return 0UL;	
			}

		// NVOiZbg
		pThis->m_bSyncSignal = true;

		// Xbh\bhs
		((pThis->m_pThreadOwner)->*(pThis->m_pTargetFunc))(pThis, pThis->m_bKillSignal, pThis->m_pThreadParam);

		// NVOiNA
		pThis->m_bSyncSignal = false;

		return 0UL;	
	}

	static void PumpMessage(void)
	{
		MSG Msg;

		// bZ[W|v쓮
		while(::PeekMessage(&Msg, NULL, 0UL, 0UL, PM_REMOVE)){
			::TranslateMessage(&Msg);
			::DispatchMessage(&Msg);
			}
	}

	T *m_pThreadOwner;
	TAGET_FUNC m_pTargetFunc;
	PVOID m_pThreadParam;

	HANDLE m_hThread;
	DWORD m_dwThreadID;

	bool m_bSyncSignal;
	bool m_bKillSignal;
};
