// BonEnumerator.cpp: FriiohCo񋓃NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonEnumerator.h"
#include <TChar.h>
#include <SetupApi.h>
#include <CfgMgr32.h>
#include <InitGuid.h>


#pragma comment(lib, "SetupApi.lib")


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// hCoCX^XGUID
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );


/////////////////////////////////////////////////////////////////////////////
// FriiohCo񋓃NX
/////////////////////////////////////////////////////////////////////////////

CBonEnumerator::CBonEnumerator(void)
{

}

CBonEnumerator::~CBonEnumerator(void)
{
	m_DeviceLock.Close();
}

const bool CBonEnumerator::EnumDevice(const bool bBlackFriio)
{
	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = ::SetupDiGetClassDevs(&GUID_FRIIO_DRIVER, 0UL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return false;

	// hCoXgNA
	m_DriverList.clear();

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);

	DWORD dwDeviceIndex = 0UL;
	TCHAR szDriverPath[_MAX_PATH];

	while(::SetupDiEnumDeviceInterfaces(hDevInfo, NULL, &GUID_FRIIO_DRIVER, dwDeviceIndex++, &DeviceInterfaceData)){
		// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
		DWORD dwBuffLen = 0UL;
		::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

		// obt@m
		dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
		SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)new BYTE [dwBuffLen];
		if(!pDeviceInterfaceDetailData)continue;
		pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

		// foCX̏ڍׂ擾
		SP_DEVINFO_DATA DevInfoData;
		DevInfoData.cbSize = sizeof(DevInfoData);
		if(!::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, &DevInfoData))continue;

		// ʃfoCX擾uUSB foCXv
		if(::CM_Get_Parent(&DevInfoData.DevInst, DevInfoData.DevInst, 0UL) == CR_SUCCESS){
	
			// ʃfoCX擾uėp USB nuv
			if(::CM_Get_Parent(&DevInfoData.DevInst, DevInfoData.DevInst, 0UL) == CR_SUCCESS){
			
				// ʃfoCX擾@:uMulti-Slots USB SmartCard ReadervA:uGeneric Usb Smart Card Readerv
				if(::CM_Get_Child(&DevInfoData.DevInst, DevInfoData.DevInst, 0UL) == CR_SUCCESS){
				
					// ʃfoCX擾@:uChild A DevicevA:u݂Ȃv
					if(((::CM_Get_Child(&DevInfoData.DevInst, DevInfoData.DevInst, 0UL) == CR_SUCCESS)? false : true) == bBlackFriio){
						
						// DriverPathǉ
						::_tcscpy(szDriverPath, pDeviceInterfaceDetailData->DevicePath);
						m_DriverList.push_back(szDriverPath);
						}
					}
				}
			}		

		// obt@J
		delete [] ((BYTE *)pDeviceInterfaceDetailData);
		}

	// foCXZbg̃nhJ
	::SetupDiDestroyDeviceInfoList(hDevInfo);

	return true;
}

LPCTSTR CBonEnumerator::GetAvailableDriverPath(void) const
{
	// p\ȃfoCX
	for(DWORD dwIndex = 0UL ; dwIndex < m_DriverList.size() ; dwIndex++){
		if(IsAvailableDevice(m_DriverList[dwIndex].c_str()))return m_DriverList[dwIndex].c_str();
		}

	return NULL;
}

const DWORD CBonEnumerator::GetTotalNum(void) const
{
	// foCX̑Ԃ
	return m_DriverList.size();
}

const DWORD CBonEnumerator::GetActiveNum(void) const
{
	DWORD dwActiveNum = 0UL;

	// gp̃foCX
	for(DWORD dwIndex = 0UL ; dwIndex < m_DriverList.size() ; dwIndex++){
		if(!IsAvailableDevice(m_DriverList[dwIndex].c_str()))dwActiveNum++;
		}

	return dwActiveNum;
}

const DWORD CBonEnumerator::GetAvailableNum(void) const
{
	DWORD AvailableNum = 0UL;

	// gpłȂfoCX
	for(DWORD dwIndex = 0UL ; dwIndex < m_DriverList.size() ; dwIndex++){
		if(!IsAvailableDevice(m_DriverList[dwIndex].c_str()))AvailableNum++;
		}

	return AvailableNum;
}

const bool CBonEnumerator::LockDevice(LPCTSTR lpszDriverPath)
{
	if(!lpszDriverPath)return false;
	if(!::_tcslen(lpszDriverPath))return false;

	// hCopX'\''/'ɒu
	TCHAR szMutexName[_MAX_PATH];
	::_tcscpy(szMutexName, lpszDriverPath);
	
	for(TCHAR *pszPos = szMutexName ; *pszPos ; pszPos++){
		if(*pszPos == TEXT('\\'))*pszPos = TEXT('/');
		}

	// Mutex擾
	return m_DeviceLock.Create(szMutexName);
}

const bool CBonEnumerator::ReleaseDevice(void)
{
	// MutexJ
	return m_DeviceLock.Close();
}

const bool CBonEnumerator::IsAvailableDevice(LPCTSTR lpszDriverPath)
{
	if(!lpszDriverPath)return false;
	if(!::_tcslen(lpszDriverPath))return false;

	// hCopX'\''/'ɒu
	TCHAR szMutexName[_MAX_PATH];
	::_tcscpy(szMutexName, lpszDriverPath);

	for(TCHAR *pszPos = szMutexName ; *pszPos ; pszPos++){
		if(*pszPos == TEXT('\\'))*pszPos = TEXT('/');
		}

	// Mutex̎擾LԂ
	return CSmartMutex::IsExist(szMutexName)? false : true;
}
