// BonWhiteTuner.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonWhiteTuner.h"
#include <Math.h>
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT(" Friio USB 2.0 Digital TV Receiver")

// obt@ݒ
#define ASYNCBUFFTIME		2UL											// obt@ = 2b
#define ASYNCBUFFNUM		(0x400000UL / TSRECVSIZE * ASYNCBUFFTIME)	// 32MbpsƂ

#define REQRESERVNUM		16UL			// 񓯊NGXg\
#define REQPOLLINGWAIT		10UL			// 񓯊NGXg|[OԊu(ms)

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_SETTSSIZE	0x00220038UL	// TSXg[TCYݒ
#define IOCODE_ABORTPIPE	0x00220044UL	// TSXg[~
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

HINSTANCE CBonWhiteTuner::m_hModule = NULL;

const BONGUID CBonWhiteTuner::GetDeviceType(void)
{
	// foCX̃^CvԂ
	return ::BON_NAME_TO_GUID(TEXT("IHalTsTuner"));
}

const DWORD CBonWhiteTuner::GetDeviceName(LPTSTR lpszName)
{
	// foCXԂ
	if(lpszName)::_tcscpy(lpszName, DEVICENAME);

	return ::_tcslen(DEVICENAME);
}

const DWORD CBonWhiteTuner::GetTotalDeviceNum(void)
{
	// FriiȏԂ
	return (m_BonEnumerator.EnumDevice(false))? m_BonEnumerator.GetTotalNum() : 0UL;
}

const DWORD CBonWhiteTuner::GetActiveDeviceNum(void)
{
	// gp̔Friio̐Ԃ
	return (m_BonEnumerator.EnumDevice(false))? m_BonEnumerator.GetActiveNum() : 0UL;
}

const bool CBonWhiteTuner::OpenTuner(void)
{
	// UN[Y
	CloseTuner();
	
	try{
		// hCo
		if(!m_BonEnumerator.EnumDevice(false))throw __LINE__;
	
		// gp̃`[i擾
		LPCTSTR lpszDriverPath = m_BonEnumerator.GetAvailableDriverPath();
		if(!lpszDriverPath)throw __LINE__;

		// hCoI[v
		if((m_hFriioDriver = ::CreateFile(lpszDriverPath, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) == INVALID_HANDLE_VALUE)throw __LINE__;

		// hCobN
		if(!m_BonEnumerator.LockDevice(lpszDriverPath))throw __LINE__;
		
		// V[PXM
		if(!SendFixedRequest(IDR_INISEQ_WHITE))throw __LINE__;
		
		// ftHg`lݒ
		if(!SetChannel(0UL, 0UL))throw __LINE__;
		
		// CxgZbg
		if(!m_TsRecvEvent.ResetEvent())throw __LINE__;
		
		// obt@m
		if(!AllocateBuffer(ASYNCBUFFNUM + REQRESERVNUM))throw __LINE__;
		
		// XbhN
		if(!m_IoReqThread.StartThread(this, &CBonWhiteTuner::IoReqThread))throw __LINE__;
		if(!m_IoRecvThread.StartThread(this, &CBonWhiteTuner::IoRecvThread))throw __LINE__;
		}
	catch(...){
		// G[
		CloseTuner();
		return false;
		}
	
	return true;
}

void CBonWhiteTuner::CloseTuner(void)
{
	// Xbh~
	m_IoReqThread.EndThread();
	m_IoRecvThread.EndThread();

	// CxgZbg(ҋ@XbhJ)
	m_TsRecvEvent.SetEvent();

	// obt@J
	ReleaseBuffer();
	
	if(m_hFriioDriver != INVALID_HANDLE_VALUE){
		// IV[PXM
		SendFixedRequest(IDR_ENDSEQ_WHITE);

		// hCoN[Y
		::CloseHandle(m_hFriioDriver);
		m_hFriioDriver = INVALID_HANDLE_VALUE;
		}

	// hCobNJ
	m_BonEnumerator.ReleaseDevice();
	
	// `l
	m_dwCurChannel = 0UL;
}

const DWORD CBonWhiteTuner::EnumTuningSpace(const DWORD dwSpace, LPTSTR lpszSpace)
{
	static const TCHAR aszTuningSpace[][16] = 
	{
		TEXT("nfW")
	};

	// gp\ȃ`[jOԂԂ
	if(dwSpace >= (sizeof(aszTuningSpace) / sizeof(aszTuningSpace[0])))return 0UL;

	// `[jOԖRs[
	if(lpszSpace)::_tcscpy(lpszSpace, aszTuningSpace[dwSpace]);

	// `[jOԖԂ
	return ::_tcslen(aszTuningSpace[dwSpace]);
}

const DWORD CBonWhiteTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel, LPTSTR lpszChannel)
{
	// gp\ȃ`lԂ
	static const TCHAR aszChannelName[][16] = 
	{
		TEXT("UHF 13ch"), TEXT("UHF 14ch"), TEXT("UHF 15ch"), TEXT("UHF 16ch"), TEXT("UHF 17ch"), TEXT("UHF 18ch"), TEXT("UHF 19ch"),
		TEXT("UHF 20ch"), TEXT("UHF 21ch"), TEXT("UHF 22ch"), TEXT("UHF 23ch"), TEXT("UHF 24ch"), TEXT("UHF 25ch"), TEXT("UHF 26ch"), TEXT("UHF 27ch"), TEXT("UHF 28ch"), TEXT("UHF 29ch"),
		TEXT("UHF 30ch"), TEXT("UHF 31ch"), TEXT("UHF 32ch"), TEXT("UHF 33ch"), TEXT("UHF 34ch"), TEXT("UHF 35ch"), TEXT("UHF 36ch"), TEXT("UHF 37ch"), TEXT("UHF 38ch"), TEXT("UHF 39ch"), 
		TEXT("UHF 40ch"), TEXT("UHF 41ch"), TEXT("UHF 42ch"), TEXT("UHF 43ch"), TEXT("UHF 44ch"), TEXT("UHF 45ch"), TEXT("UHF 46ch"), TEXT("UHF 47ch"), TEXT("UHF 48ch"), TEXT("UHF 49ch"), 
		TEXT("UHF 50ch"), TEXT("UHF 51ch"), TEXT("UHF 52ch"), TEXT("UHF 53ch"), TEXT("UHF 54ch"), TEXT("UHF 55ch"), TEXT("UHF 56ch"), TEXT("UHF 57ch"), TEXT("UHF 58ch"), TEXT("UHF 59ch"), 
		TEXT("UHF 60ch"), TEXT("UHF 61ch"), TEXT("UHF 62ch")
	};

	// gp\ȃ`lԂ
	if(!EnumTuningSpace(dwSpace, NULL))return 0UL;
	if(dwChannel >= (sizeof(aszChannelName) / sizeof(aszChannelName[0])))return 0UL;

	// `lRs[
	if(lpszChannel)::_tcscpy(lpszChannel, aszChannelName[dwChannel]);

	// `lԂ
	return ::_tcslen(aszChannelName[dwSpace]);
}

const DWORD CBonWhiteTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return 0UL;
}

const DWORD CBonWhiteTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const bool CBonWhiteTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jOV[PXϕ
	static const BYTE abyPllConfA[] = {0x81U};
	static const BYTE abyPllConfB[] = {0x40U, 0x03U, 0x00U, 0x30U, 0xFEU, 0x00U, 0x05U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x05U, 0x00U, 0x00U, 0x00U, 0xC0U, 0x00U, 0x00U, 0xB2U, 0x08U};
	static const BYTE abyPllConfC[] = {0x40U, 0x03U, 0x00U, 0x30U, 0xFEU, 0x00U, 0x05U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x05U, 0x00U, 0x00U, 0x00U, 0xC0U, 0x00U, 0x00U, 0x9AU, 0x50U};
	static const BYTE abyPllConfD[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0xB0U, 0x00U, 0x01U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x01U, 0x00U, 0x00U, 0x00U, 0x00U};
	static const BYTE abyPllConfE[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0x80U, 0x00U, 0x01U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x01U, 0x00U, 0x00U, 0x00U, 0x00U};
	static const BYTE abyPllConfF[] = {0x81U, 0x00U, 0xBCU, 0x00U, 0x00U};

	// `[jO͈̓`FbN
	if(!EnumChannelName(dwSpace, dwChannel, NULL))return false;

	// `lf[^vZ
	const WORD wChCode = 0x0E7F + 0x002A * (WORD)dwChannel;

	BYTE TxdData[256];

	// 1ڃNGXgM
	if(SendIoRequest(IOCODE_ABORTPIPE, abyPllConfA, sizeof(abyPllConfA), m_RxdBuff, 0UL) == -1)return false;
	if(SendIoRequest(IOCODE_ABORTPIPE, abyPllConfA, sizeof(abyPllConfA), m_RxdBuff, 0UL) == -1)return false;

	// 2ڃNGXgݒ
	::CopyMemory(TxdData, abyPllConfB, sizeof(abyPllConfB));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 2ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, TxdData, sizeof(abyPllConfB), m_RxdBuff, sizeof(abyPllConfB)) == -1)return false;

	// 3ڃNGXgݒ
	CopyMemory(TxdData, abyPllConfC, sizeof(abyPllConfC));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 3ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, TxdData, sizeof(abyPllConfC), m_RxdBuff, sizeof(abyPllConfC)) == -1)return false;

	// 4ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, abyPllConfD, sizeof(abyPllConfD), m_RxdBuff, sizeof(abyPllConfD)) == -1)return false;

	// 5ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, abyPllConfE, sizeof(abyPllConfE), m_RxdBuff, sizeof(abyPllConfE)) == -1)return false;

	// 6ڃNGXgM
	if(SendIoRequest(IOCODE_SETTSSIZE, abyPllConfF, sizeof(abyPllConfF), m_RxdBuff, sizeof(abyPllConfF)) == -1)return false;

	// `lXV
	m_dwCurChannel = dwChannel;

	// Xg[p[W
	PurgeStream();

	return true;
}

const bool CBonWhiteTuner::SetLnbPower(const bool bEnable)
{
	// ɔΉ
	return false;
}

const float CBonWhiteTuner::GetSignalLevel(void)
{
	// Mxv
	static const BYTE abyGetLevReq[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0x89U, 0x00U, 0x25U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x25U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x31U, 0x3AU, 0x4BU, 0x03U, 0x00U, 0x34U, 0x08U, 0x78U, 0x00U, 0x00U, 0x40U, 0x7FU, 0xDCU, 0xACU, 0x0FU, 0x00U, 0x00U, 0x00U, 0x01U, 0xE3U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x02U, 0x00U, 0x02U, 0x00U, 0x02U, 0x00U, 0x00U, 0xF4U};

	// Mobt@NA
	::ZeroMemory(m_RxdBuff, sizeof(abyGetLevReq));

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)abyGetLevReq, sizeof(abyGetLevReq), m_RxdBuff, sizeof(abyGetLevReq)) == -1)return 0.0f;

	// MxvZ
	const DWORD dwHex = ((DWORD)m_RxdBuff[40] << 16) | ((DWORD)m_RxdBuff[41] << 8) | (DWORD)m_RxdBuff[42];
	if(!dwHex)return 0.0f;

	return (float)(68.4344993f - log10((double)dwHex) * 10.0f + pow(log10((double)dwHex) - 5.045f, (double)4.0f) / 4.09f);
}

const bool CBonWhiteTuner::GetStream(BYTE **ppStream, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock AutoLock(&m_AsyncReqLock);

	// ML[珈σf[^o
	if(m_hFriioDriver == INVALID_HANDLE_VALUE){
		// `[iI[vĂȂ
		return false;
		}
	else if(m_AsyncRecvQue.empty()){
		// o\ȃf[^Ȃ
		if(ppStream)*ppStream = NULL;
		if(pdwSize)*pdwSize = 0UL;
		if(pdwRemain)*pdwRemain = 0UL;
		}
	else{	
		// f[^o
		if(ppStream)*ppStream = m_AsyncRecvQue.front()->RxdBuff;
		if(pdwSize)*pdwSize = m_AsyncRecvQue.front()->dwRxdSize;

		m_AsyncRecvQue.pop();
		
		if(pdwRemain)*pdwRemain = m_AsyncRecvQue.size();
		}

	return true;
}

void CBonWhiteTuner::PurgeStream(void)
{
	CBlockLock AutoLock(&m_AsyncReqLock);

	// ML[NA
	while(!m_AsyncRecvQue.empty())m_AsyncRecvQue.pop();
}

const DWORD CBonWhiteTuner::WaitStream(const DWORD dwTimeOut)
{
	// Xg[EFCg
	return m_TsRecvEvent.WaitEvent(dwTimeOut);
}

const DWORD CBonWhiteTuner::GetAvailableNum(void)
{
	// o\Xg[Ԃ
	return m_AsyncRecvQue.size();
}

CBonWhiteTuner::CBonWhiteTuner(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_hFriioDriver(NULL)
	, m_dwCurChannel(0UL)
{

}

CBonWhiteTuner::~CBonWhiteTuner(void)
{
	CloseTuner();
}

void CBonWhiteTuner::SetModuleHandle(const HINSTANCE hModule)
{
	// W[nho^
	m_hModule = hModule;
}

const int CBonWhiteTuner::SendIoRequest(const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// Mf[^Rs[
	::CopyMemory(m_TxdBuff, pTxdData, dwTxdSize);

	// f[^M
	DWORD dwReturned = 0UL;
	const BOOL bReturn = ::DeviceIoControl(m_hFriioDriver, dwIoCode, m_TxdBuff, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bReturn){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(m_hFriioDriver, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

const bool CBonWhiteTuner::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// f[^M
		if(SendIoRequest(pFixedReqHead->dwIoCode, pFixedBuff, pFixedReqHead->wTxdSize, m_RxdBuff, pFixedReqHead->wRxdSize) == -1)return false;
		pFixedBuff += pFixedReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
		}

	return true;
}

const bool CBonWhiteTuner::AllocateBuffer(const DWORD dwBufferNum)
{
	// obt@mۂ
	m_AsyncReqPool.resize(dwBufferNum);
	if(m_AsyncReqPool.size() < dwBufferNum)return false;

	// obt@v[ʒu
	m_itAsyncReq = m_AsyncReqPool.begin();

	return true;
}

void CBonWhiteTuner::ReleaseBuffer(void)
{
	// NGXgL[J
	while(!m_AsyncReqQue.empty())m_AsyncReqQue.pop();

	// ML[J
	while(!m_AsyncRecvQue.empty())m_AsyncRecvQue.pop();

	// obt@J
	m_AsyncReqPool.clear();
}

void CBonWhiteTuner::IoReqThread(CSmartThread<CBonWhiteTuner> *pThread, bool &bKillSignal, PVOID pParam)
{
	// hCoɃXg[NGXg𔭍s
	while(!bKillSignal){
		// NGXg҂K薢Ȃǉ
		if(m_AsyncReqQue.size() < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s
			if(!PushIoRequest())break;

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}
}

void CBonWhiteTuner::IoRecvThread(CSmartThread<CBonWhiteTuner> *pThread, bool &bKillSignal, PVOID pParam)
{
	// σNGXg|[OăNGXg
	while(!bKillSignal){
		// σf[^΃NGXg
		if(m_AsyncReqQue.size() && (m_AsyncRecvQue.size() < ASYNCBUFFNUM)){

			// NGXg
			if(!PopIoRequest())break;

			continue;
			}

		// σL[t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}
}

const bool CBonWhiteTuner::PushIoRequest(void)
{
	// Xg[NGXg
	static const BYTE abyStreamReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// NGXgL[ɃNGXgǉ
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return false;

	// NGXgݒ
	m_itAsyncReq->dwRxdSize = 0UL;
	::CopyMemory(m_itAsyncReq->TxdBuff, abyStreamReq, sizeof(abyStreamReq));
	::ZeroMemory(&m_itAsyncReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_itAsyncReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return false;
	
	// NGXgs
	if(!::DeviceIoControl(m_hFriioDriver, IOCODE_STREAM, m_itAsyncReq->TxdBuff, sizeof(abyStreamReq), m_itAsyncReq->RxdBuff, TSRECVSIZE, &m_itAsyncReq->dwRxdSize, &m_itAsyncReq->OverLapped)){
		if(::GetLastError() != ERROR_IO_PENDING){
			::CloseHandle(m_itAsyncReq->OverLapped.hEvent);
			return false;
			}
		}

	// L[ɓ
	m_AsyncReqLock.Lock();
	m_AsyncReqQue.push(&(*m_itAsyncReq));
	if(++m_itAsyncReq == m_AsyncReqPool.end())m_itAsyncReq = m_AsyncReqPool.begin();
	m_AsyncReqLock.Unlock();
	
	return true;
}

const bool CBonWhiteTuner::PopIoRequest(void)
{
	// NGXgL[珈σf[^oAML[ɒǉ
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return false;

	// NGXgʎ擾
	m_AsyncReqLock.Lock();
	ASYNC_REQ_DATA *pFrontReq = m_AsyncReqQue.front();
	m_AsyncReqLock.Unlock();
	
	if(!::GetOverlappedResult(m_hFriioDriver, &pFrontReq->OverLapped, &pFrontReq->dwRxdSize, FALSE)){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// AEFCg
			::Sleep(REQPOLLINGWAIT);
			return true;
			}
		else{
			// G[
			::CloseHandle(pFrontReq->OverLapped.hEvent);		
			return false;
			}
		}

	// CxgJ
	::CloseHandle(pFrontReq->OverLapped.hEvent);

	// L[oAǉ
	m_AsyncReqLock.Lock();
	m_AsyncReqQue.pop();
	m_AsyncRecvQue.push(pFrontReq);
	m_AsyncReqLock.Unlock();

	// CxgZbg
	m_TsRecvEvent.SetEvent();

	return true;
}
