// TsPidMapper.cpp: PID}bpNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsPidMapper.h"


/////////////////////////////////////////////////////////////////////////////
// ITsPidMapperNX
/////////////////////////////////////////////////////////////////////////////

const bool CTsPidMapper::StorePacket(const ITsPacket *pTsPacket)
{
	if(!pTsPacket)return false;

	const WORD wPID = pTsPacket->GetPID();
	
	if(wPID >= 0x2000U)return false;				// PID͈͊O
	if(!m_apMapTarget[wPID])return false;			// PID}bv^[QbgȂ

	// PID}bv^[QbgɃpPbg
	return m_apMapTarget[wPID]->StorePacket(pTsPacket);
}

void CTsPidMapper::ResetPid(const WORD wPID)
{
	if(wPID < 0x2000U){
		// w^[QbgZbg
		if(m_apMapTarget[wPID]){
			m_apMapTarget[wPID]->OnPidReset(this, wPID);
			}
		}
	else{
		// S^[QbgZbg
		for(WORD wPID = 0x0000U ; wPID < 0x2000U ; wPID++){
			if(m_apMapTarget[wPID]){
				m_apMapTarget[wPID]->OnPidReset(this, wPID);
				}
			}
		}
}

const bool CTsPidMapper::MapPid(const WORD wPID, ITsPidMapTarget *pTsPidMapTarget)
{
	if((wPID >= 0x2000U) || !pTsPidMapTarget)return false;

	// ݂̃^[QbgA}bv
	UnmapPid(wPID);

	// V^[Qbg}bv
	m_apMapTarget[wPID] = pTsPidMapTarget;
	m_wMapTargetNum++;
	
	// nhĂяo
	pTsPidMapTarget->OnPidMapped(this, wPID);

	return true;
}

const bool CTsPidMapper::UnmapPid(const WORD wPID)
{
	if(wPID >= 0x2000U)return false;

	if(!m_apMapTarget[wPID])return false;

	// ݂̃^[QbgA}bv
	ITsPidMapTarget * const pOldTarget = m_apMapTarget[wPID];
	m_apMapTarget[wPID] = NULL;
	m_wMapTargetNum--;

	// nhĂяo
	pOldTarget->OnPidUnmapped(this, wPID);

	return true;
}

void CTsPidMapper::ClearPid(void)
{
	// S^[QbgA}bv
	for(WORD wPID = 0x0000U ; wPID < 0x2000U ; wPID++){
		UnmapPid(wPID);
		}
}

ITsPidMapTarget * CTsPidMapper::GetMapTarget(const WORD wPID) const
{
	// }bvĂ^[QbgԂ
	return (wPID <= 0x1FFFU)? m_apMapTarget[wPID] : NULL;
}

const WORD CTsPidMapper::GetMapNum(void) const
{
	// }bvςPIDԂ
	return m_wMapTargetNum;
}

CTsPidMapper::CTsPidMapper(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_wMapTargetNum(0U)
{
	// PID}bv
	::ZeroMemory(m_apMapTarget, sizeof(m_apMapTarget));
}

CTsPidMapper::~CTsPidMapper(void)
{
	ClearPid();
}
