// ConfigData.h: CConfigData NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

//////////////////////////////////////////////////////////////////////
// ZNV̒`
//////////////////////////////////////////////////////////////////////

enum
{
	CONFSECT_GENERAL
};


//////////////////////////////////////////////////////////////////////
// C^tF[X(ݒۑpɕs̃f[^^)
//////////////////////////////////////////////////////////////////////

class CConfigData  
{
public:
	CConfigData(const UINT nSection, LPCTSTR lpszKeyName);
	virtual ~CConfigData(void);

	virtual void Load(void) = 0;
	virtual void Save(void) = 0;

protected:
	// ݒt@C̃pXƃZNVǗ
	class CConfigFile
	{
	public:
		CConfigFile(void);
		virtual ~CConfigFile(void);

		LPCTSTR GetPath(void);
		LPCTSTR GetSection(const UINT nSection);

	protected:
		TCHAR m_szConfigPath[_MAX_PATH + 1];
	};

	static CConfigFile m_ConfigFile;

	// ACȅ(ZNVAL[)
	CString m_csKeyName;
	UINT m_nSection;
};


//////////////////////////////////////////////////////////////////////
// s BOOL f[^^
//////////////////////////////////////////////////////////////////////

class CConfigBool : public CConfigData
{
public:
	CConfigBool(const UINT nSection, LPCTSTR lpszKeyName, const BOOL bDefault = FALSE);
	virtual ~CConfigBool(void);

	virtual void Load(void);
	virtual void Save(void);

	operator const BOOL () const;
	operator BOOL & ();
	operator BOOL * ();
	const BOOL & operator = (const BOOL bValue);

private:
	BOOL m_bDefault;
	BOOL m_bValue;
};


//////////////////////////////////////////////////////////////////////
// s DWORD f[^^
//////////////////////////////////////////////////////////////////////

class CConfigDword : public CConfigData
{
public:
	CConfigDword(const UINT nSection, LPCTSTR lpszKeyName, const DWORD dwDefault = 0, const DWORD dwRangeMax = 0xFFFFFFFF, const DWORD dwRangeMin = 0);
	virtual ~CConfigDword(void);

	virtual void Load(void);
	virtual void Save(void);

	operator DWORD () const;
	operator DWORD & ();
	operator DWORD * ();
	const DWORD & operator = (const DWORD dwValue);

private:
	DWORD m_dwDefault;
	DWORD m_dwRangeMax;
	DWORD m_dwRangeMin;
	DWORD m_dwValue;
};


//////////////////////////////////////////////////////////////////////
// s CString f[^^
//////////////////////////////////////////////////////////////////////

class CConfigString : public CConfigData, public CString
{
public:
	CConfigString(const UINT nSection, LPCTSTR lpszKeyName, LPCTSTR lpszDefault = NULL, const DWORD dwLengthMax = 1024);
	virtual ~CConfigString(void);

	virtual void Load(void);
	virtual void Save(void);

	const CString& operator = (const CString& stringSrc);
	const CString& operator = (TCHAR ch);
	const CString& operator = (const unsigned char* psz);
	const CString& operator = (LPCWSTR lpsz);
	const CString& operator = (LPCSTR lpsz);

private:
	CString m_csDefault;
	DWORD m_dwLengthMax;
};
